commit 816f0e98f55abc3a7cfee0adb1181410f2227fcf
Author: Jan Pašek <janpasek97@gmail.com>
Date:   Mon Mar 29 13:59:16 2021 +0200

    Re #8474 - Created create_certificate.html for creating certificates

diff --git a/static/create_certificate.html b/static/create_certificate.html
new file mode 100644
index 0000000..62c5084
--- /dev/null
+++ b/static/create_certificate.html
@@ -0,0 +1,107 @@
+<!DOCTYPE html>
+<html lang="en">
+<head>
+    <meta charset="UTF-8">
+    <title>X.509 Certificate Management</title>
+</head>
+<body>
+    <h1>Create certificate</h1>
+
+    <table>
+        <tr>
+            <td><label for="CA">Choose a car:</label></td>
+            <td>
+                <select name="CA" id="CA">
+                    <option value="volvo">Self-Signed</option>
+                    <option value="#test-cert-id">Test</option>
+                </select>
+            </td>
+        </tr>
+        <tr>
+            <td><label for="validity_start">Validity start:</label></td>
+            <td><input type="date" id="validity_start" name="validity_start"></td>
+        </tr>
+        <tr>
+            <td><label for="validity_end">Validity end:</label></td>
+            <td><input type="date" id="validity_end" name="validity_end"></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_CN">Common Name:</label></td>
+            <td><input type="text" id="issuer_CN" name="issuer_CN" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_C">Country Code:</label></td>
+            <td><input type="text" id="issuer_C" name="issuer_C" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_L">Locality:</label></td>
+            <td><input type="text" id="issuer_L" name="issuer_L" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_ST">Province/State:</label></td>
+            <td><input type="text" id="issuer_ST" name="issuer_ST" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_O">Organization:</label></td>
+            <td><input type="text" id="issuer_O" name="issuer_O" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_OU">Organization Unit:</label></td>
+            <td><input type="text" id="issuer_OU" name="issuer_OU" disabled></td>
+        </tr>
+        <tr>
+            <td><label for="issuer_emailAddress">Email:</label></td>
+            <td><input type="email" id="issuer_emailAddress" name="issuer_emailAddress" disabled></td>
+        </tr>
+                <tr>
+            <td><label for="subject_CN">Common Name:</label></td>
+            <td><input type="text" id="subject_CN" name="subject_CN"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_C">Country Code:</label></td>
+            <td><input type="text" id="subject_C" name="subject_C"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_L">Locality:</label></td>
+            <td><input type="text" id="subject_L" name="subject_L"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_ST">Province/State:</label></td>
+            <td><input type="text" id="subject_ST" name="subject_ST"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_O">Organization:</label></td>
+            <td><input type="text" id="subject_O" name="subject_O"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_OU">Organization Unit:</label></td>
+            <td><input type="text" id="subject_OU" name="subject_OU"></td>
+        </tr>
+        <tr>
+            <td><label for="subject_emailAddress">Email:</label></td>
+            <td><input type="email" id="subject_emailAddress" name="subject_emailAddress"></td>
+        </tr>
+        <tr>
+            <td>Usage:</td>
+            <td>
+                <input type="checkbox" id="isCA" name="isCA" value="CA">
+                <label for="isCA">CA</label><br>
+
+                <input type="checkbox" id="isDigitalSignature" name="isDigitalSignature" value="DigitalSignature">
+                <label for="isDigitalSignature">Digital Signature</label><br>
+
+                <input type="checkbox" id="isAuthentication" name="isAuthentication" value="Authentication">
+                <label for="isAuthentication">Authentication</label><br>
+
+                <input type="checkbox" id="isSSL_TLS" name="isSSL_TLS" value="SSL_TLS">
+                <label for="isSSL_TLS">SSL/TLS</label><br>
+            </td>
+        </tr>
+        <tr>
+            <td colspan="2" align="center">
+                <button onclick="window.location.href = '/static/index.html';">Create certificate</button>
+            </td>
+        </tr>
+    </table>
+</body>
+</html>
\ No newline at end of file